VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmAccess 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   5655
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   6030
   Icon            =   "frmAccess.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5655
   ScaleWidth      =   6030
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame2 
      Height          =   5535
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   5775
      Begin VB.CommandButton cmdAddAccess 
         Appearance      =   0  'Flat
         Caption         =   "Add Access"
         Height          =   375
         Left            =   3840
         TabIndex        =   7
         Top             =   4680
         Width           =   1815
      End
      Begin VB.CommandButton cmdModifyAccess 
         Appearance      =   0  'Flat
         Caption         =   "Modify Access"
         Height          =   375
         Left            =   2040
         TabIndex        =   6
         Top             =   4680
         Width           =   1695
      End
      Begin VB.CommandButton cmdRemoveAccess 
         Appearance      =   0  'Flat
         Caption         =   "Remove Access"
         Height          =   375
         Left            =   120
         TabIndex        =   5
         Top             =   4680
         Width           =   1815
      End
      Begin MSComctlLib.ListView lvAccess 
         Height          =   4095
         Left            =   120
         TabIndex        =   1
         Top             =   480
         Width           =   5515
         _ExtentX        =   9737
         _ExtentY        =   7223
         View            =   3
         LabelEdit       =   1
         LabelWrap       =   -1  'True
         HideSelection   =   -1  'True
         HideColumnHeaders=   -1  'True
         Checkboxes      =   -1  'True
         _Version        =   393217
         ForeColor       =   -2147483640
         BackColor       =   -2147483643
         BorderStyle     =   1
         Appearance      =   0
         MousePointer    =   1
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "Arial"
            Size            =   9
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         NumItems        =   3
         BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            Text            =   "Username"
            Object.Width           =   3981
         EndProperty
         BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            SubItemIndex    =   1
            Text            =   "Access"
            Object.Width           =   1411
         EndProperty
         BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
            SubItemIndex    =   2
            Text            =   "Added By"
            Object.Width           =   3804
         EndProperty
      End
      Begin VB.Label lblStatus 
         Alignment       =   2  'Center
         Caption         =   ". . ."
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   5160
         Width           =   5535
      End
      Begin VB.Label Label4 
         Caption         =   "Added By"
         Height          =   255
         Left            =   3260
         TabIndex        =   4
         Top             =   240
         Width           =   1215
      End
      Begin VB.Label Label3 
         Caption         =   "Access"
         Height          =   255
         Left            =   2460
         TabIndex        =   3
         Top             =   240
         Width           =   735
      End
      Begin VB.Label Label2 
         Caption         =   "Username"
         Height          =   255
         Left            =   150
         TabIndex        =   2
         Top             =   240
         Width           =   1335
      End
   End
End
Attribute VB_Name = "frmAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim form_ProfileIndex As Integer
'holds the index of the profile currently using this form
'used for remembering where to save things and such

Private Sub cmdModifyAccess_Click()

    If Not aProfile(form_ProfileIndex).Connected Then
        AddChat 0, botElements.ActiveChatIndex, vbYellow, GetSTRING(165) 'Notice --- Selected profile is not connected, cannot add access.
        lblStatus.Caption = GetSTRING(165)
        'add chat to profile open and access list
        Exit Sub
    End If
    'if not connected cannot proceed, since adding access requires username conversion

    UsersSelected = get_SelectedUsernames
    If InStrB(UsersSelected, AZero) Then
        Dim userSplit() As String
        userSplit = Split(UsersSelected, AZero)
        'builds into array
        If UBound(userSplit) > 1 Then
            Dim msgResult As Integer
            msgResult = MsgBox("You are about to modify access for " & UBound(userSplit) & " users. Do you want to continue?", vbYesNo, "Modify multiple users")
            If msgResult <> 6 Then Exit Sub
        End If
        
        Dim boxResponse1 As String
        boxResponse1 = InputBox("What access would you like to set the selected users to?" & vbCrLf & "Max 998.", "Modify Access")
        'get response
        If Val#(boxResponse1) > 998 Or Val#(boxResponse1) < 1 Then Exit Sub
        'not a valid input
        Dim arrIndex As Integer
        For arrIndex = 0 To (UBound(userSplit) - 1)
            ModifyAccess aProfile(form_ProfileIndex).RealName, 999, Val#(boxResponse1), lvAccess.ListItems(Val#(userSplit(arrIndex))).Text, False, vbNullString, form_ProfileIndex, True
        Next arrIndex
        'modify all users
        SaveAccess form_ProfileIndex
        'save changes
        Load_AccessDisplay
        'show new
        lblStatus.Caption = "Updated access for " & UBound(userSplit) & " users. New access for users is " & boxResponse1 & "."
    Else
        lblStatus.Caption = "No users selected to modify."
    End If


End Sub

Private Sub cmdRemoveAccess_Click()
Dim UsersSelected As String

    UsersSelected = get_SelectedUsernames
    If InStrB(UsersSelected, AZero) Then
        Dim userSplit() As String
        userSplit = Split(UsersSelected, AZero)
        'builds into array
        If UBound(userSplit) > 1 Then
            Dim msgResult As Integer
            msgResult = MsgBox("You are about to remove " & UBound(userSplit) & " users. Do you want to continue?", vbYesNo, "Remove multiple users")
            If msgResult <> 6 Then Exit Sub
        End If
        Dim arrIndex As Integer
        For arrIndex = 0 To (UBound(userSplit) - 1)
            Remove_Access False, lvAccess.ListItems(Val#(userSplit(arrIndex))).Text, form_ProfileIndex
            'removes selected user
        Next arrIndex
        'remove all
        SaveAccess form_ProfileIndex
        'save changes
        Load_AccessDisplay
        'show new
        lblStatus.Caption = "Removed " & UBound(userSplit) & " users."
    Else
        lblStatus.Caption = "No users selected to modify."
    End If
    
End Sub

Private Function get_SelectedUsernames() As String
Dim arrIndex As Integer

    If lvAccess.ListItems.Count = 0 Then Exit Function
    'none found
    For arrIndex = 1 To lvAccess.ListItems.Count
      If lvAccess.ListItems(arrIndex).Checked Then get_SelectedUsernames = get_SelectedUsernames & arrIndex & AZero
    Next arrIndex
    'gather all entries that are checked

End Function

Private Sub Form_Load()
    FormsOpen.Access = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    FormsOpen.Access = False
End Sub
'states that the form is no longer open

Public Function get_ProfileIndex() As Integer
    get_ProfileIndex = form_ProfileIndex
End Function
'checked when user logs on, to see if they changed their name or anything

Public Sub Set_ProfileIndex(ByRef Index As Integer)
    
    form_ProfileIndex = Index
    'set profile using this form
    Me.Caption = "Access List For: " & aProfile(Index).Name & "." & ChangeRealmIndexToName(Index)
    'caption
    Load_AccessDisplay
    'editing access

End Sub
'set the profile changing settings


Public Sub Load_AccessDisplay()
Dim AccessString As String, AccessSplit() As String, arrIndex As Integer
Dim AddedBySplit() As String, AddedByString As String

On Error GoTo Err

    lvAccess.Sorted = False
    'disable sorting. some reason sorting messes up the display if done before all entries are added
    lvAccess.ListItems.Clear
    'clear list
    If aProfile(form_ProfileIndex).AccessUnique Then
        AccessString = aProfile(form_ProfileIndex).AccessUsers
        AddedByString = aProfile(form_ProfileIndex).AccessAdders
    'profile specific access
    Else
        AccessString = botElements.AccessUsers
        AddedByString = botElements.AccessAdders
    'use global
    End If
    'sets which access to use
    If LenB(AccessString) Then
    'if any users have access
        Dim theName As String, theAccess As String, StringLoc As Integer
        AccessSplit() = Split(AccessString, AUnderT)
        AddedBySplit() = Split(AddedByString, AZero)
        '
        For arrIndex = 0 To UBound(AccessSplit)
            If LenB(AccessSplit(arrIndex)) Then
            'if not a null entry
                StringLoc = InStr(AccessSplit(arrIndex), ASnake)
                If StringLoc <> 0 Then
                'if identifiers found
                    theName = Mid$(AccessSplit(arrIndex), 2, (StringLoc - 2))
                    theAccess = Mid$(AccessSplit(arrIndex), (StringLoc + 1))
                    'split the name and access
                    lvAccess.ListItems.Add , , theName
                    lvAccess.ListItems.Item(lvAccess.ListItems.Count).ListSubItems.Add , , theAccess
                    lvAccess.ListItems.Item(lvAccess.ListItems.Count).ListSubItems.Add , , AddedBySplit(arrIndex)
                End If
            End If
        Next arrIndex
    'if access string isnt null
    End If
    
    lvAccess.SortKey = 1
    lvAccess.SortOrder = lvwAscending
    lvAccess.Sorted = True
    'sort by access after all items have been added
    lblStatus.Caption = "Access List loaded."
    If lvAccess.ListItems.Count > 0 Then
        For arrIndex = 1 To lvAccess.ListItems.Count
            lvAccess.ListItems(arrIndex).Selected = False
        Next arrIndex
    End If
    'some reason only semi effective way to remove a selection that occurs at random
    Exit Sub
Err:
    lblStatus.Caption = "An error occured: " & Err.Number
End Sub
'loads access for display


Private Sub cmdAddAccess_Click()
Dim boxResponse1 As String
Dim boxResponse2 As String

    If Not aProfile(form_ProfileIndex).Connected Then
        AddChat 0, botElements.ActiveChatIndex, vbYellow, GetSTRING(165) 'Notice --- Selected profile is not connected, cannot add access.
        lblStatus.Caption = GetSTRING(165)
        'add chat to profile open and access list
        Exit Sub
    End If
    'if not connected cannot proceed, since adding access requires username conversion
    
    boxResponse1 = InputBox("Who do you wish to add to access?", "Add Access")
    If LenB(boxResponse1) And aProfile(form_ProfileIndex).Connected Then
    'if not null and still connected
        boxResponse1 = FirstNameConversion(boxResponse1, form_ProfileIndex)
        'convert
        boxResponse2 = InputBox("How much access will '" & boxResponse1 & "' have? " & vbCrLf & "Max 998.", "Add Access")
        'prompt for amount
        If aProfile(form_ProfileIndex).Connected Then
        'if bot still connected
            If Val#(boxResponse2) > 0 And Val#(boxResponse2) < 999 Then
            'if within allowed values then add
                Do Until Len(boxResponse2) = 3
                    boxResponse2 = "0" & boxResponse2
                Loop
                'force 3 in length
                If get_Access(boxResponse1, form_ProfileIndex) <> 0 Then
                'Already has access, modify instead
                    ModifyAccess aProfile(form_ProfileIndex).RealName, 999, Val#(boxResponse2), boxResponse1, False, vbNullString, form_ProfileIndex, True
                    'already has access, modify instead of add
                    lblStatus.Caption = "Updated access for " & boxResponse1 & " to " & boxResponse2 & "."
                Else
                'doesnt have, add
                    AddChat 0, form_ProfileIndex, vbYellow, GetSTRING(113) & boxResponse1 & GetSTRING(118) & boxResponse2 & GetSTRING(122)
                    'chat
                    Add_Access aProfile(form_ProfileIndex).RealName, boxResponse1, Val#(boxResponse2), form_ProfileIndex
                    'add
                End If
                'check if already have access
                Load_AccessDisplay
                'updates display
            'if access is within allowed values
            End If
        'if access isnt null and profile is still connected
        End If
    'if not null and still connected for name
    End If
    
End Sub
'adds a user to the access list

Private Sub lvAccess_ItemClick(ByVal Item As MSComctlLib.ListItem)
    Set lvAccess.SelectedItem = Nothing
End Sub
