VERSION 5.00
Begin VB.Form frmClanCreator 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Clan Creator"
   ClientHeight    =   4230
   ClientLeft      =   7380
   ClientTop       =   2580
   ClientWidth     =   4470
   ForeColor       =   &H8000000A&
   Icon            =   "frmClanCreator.frx":0000
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4230
   ScaleWidth      =   4470
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame FrameClanCreator 
      Height          =   4095
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   4215
      Begin VB.CommandButton cmdHide 
         Appearance      =   0  'Flat
         Caption         =   "Hide Clan Creator"
         Height          =   375
         Left            =   2160
         TabIndex        =   12
         Top             =   3000
         Width           =   1935
      End
      Begin VB.ListBox LstAvail 
         Appearance      =   0  'Flat
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   1785
         Left            =   120
         TabIndex        =   2
         Top             =   480
         Width           =   1935
      End
      Begin VB.CommandButton CmdCreate 
         Appearance      =   0  'Flat
         Caption         =   "Create Clan"
         Height          =   375
         Left            =   2520
         TabIndex        =   7
         Top             =   2520
         Width           =   1575
      End
      Begin VB.CommandButton CmdCheckAvailability 
         Appearance      =   0  'Flat
         Caption         =   "Check Availability"
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   3000
         Width           =   1935
      End
      Begin VB.TextBox txtClanTag 
         Appearance      =   0  'Flat
         Height          =   285
         Left            =   1560
         MaxLength       =   4
         TabIndex        =   5
         Top             =   2640
         Width           =   855
      End
      Begin VB.TextBox txtClanName 
         Appearance      =   0  'Flat
         Height          =   285
         Left            =   120
         TabIndex        =   3
         Top             =   2640
         Width           =   1335
      End
      Begin VB.ListBox LstCanidates 
         Appearance      =   0  'Flat
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   1785
         Left            =   2160
         TabIndex        =   1
         Top             =   480
         Width           =   1935
      End
      Begin VB.CheckBox CheckClanAutoAccept 
         Appearance      =   0  'Flat
         Caption         =   "Auto accept clan invites for tag: unspecified"
         ForeColor       =   &H80000008&
         Height          =   495
         Left            =   120
         TabIndex        =   11
         Top             =   3480
         Width           =   3975
      End
      Begin VB.Label Label4 
         Caption         =   "Choosen Canidates"
         Height          =   255
         Left            =   2160
         TabIndex        =   10
         Top             =   240
         Width           =   1935
      End
      Begin VB.Label Label3 
         Caption         =   "Available Canidates"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   240
         Width           =   1935
      End
      Begin VB.Label Label2 
         Caption         =   "Clan Tag"
         Height          =   255
         Left            =   1560
         TabIndex        =   4
         Top             =   2400
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Clan Name"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   2400
         Width           =   1215
      End
   End
End
Attribute VB_Name = "frmClanCreator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Compare Binary
Option Explicit

Dim ClanCreatorProfileIndex As Integer

Private Sub CmdCheckAvailability_Click()
 
  If LenB(frmClanCreator.txtClanTag.Text) = 0 Or Not aProfile(ClanCreatorProfileIndex).Connected Or Len(aProfile(ClanCreatorProfileIndex).CDKey) <> 26 Then Exit Sub
  'if not connected or fake tag

  frmClanCreator.LstAvail.Clear
  frmClanCreator.LstCanidates.Clear
  'so we dont have old results
  AddChat 0, botElements.ActiveChatIndex, &H8000&, GetSTRING(92), vbGreen, frmClanCreator.txtClanTag.Text  'Checking clan creation availability for tag,
  'checking for avail
  PBuffer.InsertDWORD 0
  PBuffer.InsertDWORD PBuffer.GetDWORD(StrReverse$(frmClanCreator.txtClanTag.Text))
  PBuffer.sendPacket &H70, ClanCreatorProfileIndex
  'send packets

End Sub
'checks for tag avail



Private Sub CmdCreate_Click()
Dim iListindex As Byte, sNames As String

  If LenB(frmClanCreator.txtClanTag.Text) = 0 Or Not aProfile(ClanCreatorProfileIndex).Connected Or Len(aProfile(ClanCreatorProfileIndex).CDKey) <> 26 Or LenB(frmClanCreator.txtClanName.Text) = 0 Then Exit Sub
  'if not connected or fake tag
  
  If frmClanCreator.LstCanidates.ListCount <> 9 Then

    AddChat 0, botElements.ActiveChatIndex, vbYellow, GetSTRING(105) 'Cannot create clan, choosen canidate count must be exactly 9.
  
  Else
    
    Do Until LenB(frmClanCreator.LstCanidates.List(iListindex)) = 0
      sNames = sNames & frmClanCreator.LstCanidates.List(iListindex) & vbNullChar
      iListindex = iListindex + 1
    Loop
    
    AddChat 0, botElements.ActiveChatIndex, &H8000&, GetSTRING(106), vbGreen, frmClanCreator.txtClanTag.Text & "."  'Sending out clan creation invites for
    'checking for avail
    PBuffer.InsertDWORD 3
    PBuffer.InsertNTString frmClanCreator.txtClanName.Text
    PBuffer.InsertDWORD PBuffer.GetDWORD(StrReverse$(frmClanCreator.txtClanTag.Text))
    PBuffer.InsertBYTE "&H9" '9 canidates
    PBuffer.InsertNonNTString sNames
    PBuffer.sendPacket &H71, ClanCreatorProfileIndex

    'invitations sent
    
  End If
  
End Sub
'start clan (send 9 invites)

Private Sub cmdHide_Click()
    MsgBox "This Form will now be hidden, select Tools -> Clan Creator to show again."
    Me.Visible = False
End Sub

Private Sub Form_Load()
    FormsOpen.ClanCreator = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    FormsOpen.ClanCreator = False
End Sub

Private Sub LstAvail_Click()

  If LenB(LstAvail.List(LstAvail.listIndex)) Then
    LstCanidates.AddItem LstAvail.List(LstAvail.listIndex)
    LstAvail.RemoveItem (LstAvail.listIndex)
  End If

End Sub
'moves avail to canidates


Private Sub LstCanidates_Click()
  
  If LenB(LstCanidates.List(LstCanidates.listIndex)) Then
    LstAvail.AddItem LstCanidates.List(LstCanidates.listIndex)
    LstCanidates.RemoveItem (LstCanidates.listIndex)
  End If

End Sub
'moves canidates to avail


Private Sub txtClanTag_Change()

  If LenB(frmClanCreator.txtClanTag.Text) <> 0 Then
    frmClanCreator.CheckClanAutoAccept.Caption = "Auto accept clan invites for tag: " & frmClanCreator.txtClanTag.Text
  'accept from displayed tag
  Else
    frmClanCreator.CheckClanAutoAccept.Caption = "Auto accept clan invites for tag: unspecified"
  'no tag specified
  End If

End Sub
'change auto accept appearance


Public Sub Set_ProfileIndex(Index As Integer)
  
    frmClanCreator.Caption = "Clan Creator - Chieftain: " & aProfile(Index).RealName
    ClanCreatorProfileIndex = Index

  
End Sub
'sets index and type of tool choice

Public Function get_ProfileIndex() As Integer
    get_ProfileIndex = ClanCreatorProfileIndex
End Function
'returns the stored index
