VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PacketBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Compare Binary
Option Explicit

Dim readLoc As Long
Dim RecvBuffer As String
Dim SendBuffer As String

Public Sub InsertDWORDArray(Data() As Long)
    Dim i As Integer
    For i = LBound(Data) To UBound(Data) Step 1
        SendBuffer = SendBuffer & MakeDWORD(Data(i))
    Next i
End Sub

Public Sub InsertDWORD(Data As Long)
    SendBuffer = SendBuffer & MakeDWORD(Data)
End Sub

Public Sub InsertBYTE(Data As Integer)
    SendBuffer = SendBuffer & Chr$(Data)
End Sub

Public Sub InsertBytes(Data As String)
    Dim i As Long
    Dim Enqueueer As String
    For i = 1 To Len(Data) Step 3
        Enqueueer = Enqueueer & Chr$(Val#("&h0" & Mid$(Data, i, 2)))
    Next i
    SendBuffer = SendBuffer & Enqueueer
End Sub

Public Sub InsertNTString(Data As String)
    SendBuffer = SendBuffer & Data & vbNullChar
End Sub

Public Sub InsertNonNTString(Data As String)
    SendBuffer = SendBuffer & Data
End Sub

Public Function MakeDWORD(ByVal Value As Long) As String
    Dim Result As String * 4
    CopyMemory ByVal Result, Value, 4
    MakeDWORD = Result
End Function

Public Function MakeWORD(ByVal Value As Integer) As String
    Dim Result As String * 2
    CopyMemory ByVal Result, Value, 2
    MakeWORD = Result
End Function


Public Sub sendPacket(ByRef PPacketID As Byte, ByRef Index As Integer)
On Error GoTo Err
              
    If Not aProfile(Index).Connected Then
        Dim PacketString As String
        'variables
        Select Case PPacketID
            Case &H25, &H14, &HB, &HC, &H5B, &H5A, &H59, &HE
            'packets to ignore
            Case &HA
              If aProfile(Index).GameClient = Str_3RAW Then PacketString = "A,B,C"
              'only show if w3
            'special string reply packets
            Case Else
              PacketString = Hex(PPacketID)
            'normal packet
        End Select
        'determine text
        If LenB(PacketString) Then AddChat 0, Index, vbGreen, "Packet -> Sent 0x" & PacketString & "."
        'chat
    End If
    'displays sent text
    
    frmMain.wS(Index).SendData Chr$(&HFF) & Chr$(PPacketID) & MakeWORD(Len(SendBuffer) + 4) & SendBuffer
    'sends
            
    If aProfile(Index).QueueRaiseFactor < 60 Then aProfile(Index).QueueRaiseFactor = aProfile(Index).QueueRaiseFactor + 1
    'increase 1
    
Err:
    SendBuffer = vbNullString
End Sub

Public Sub SendBNLSPacket(PPacketID As Byte, Index As Integer)
On Error GoTo Err

  SendBuffer = MakeWORD(Len(SendBuffer) + 3) & Chr$(PPacketID) & SendBuffer
  
  frmMain.Bnls_wS(Index).SendData SendBuffer
  SendBuffer = vbNullString
 
Err:
End Sub

Public Sub InsertWORD(Data As Integer)
    SendBuffer = SendBuffer & MakeWORD(Data)
End Sub
Public Sub Clear()
    SendBuffer = vbNullString
End Sub

Public Function GetInboundData() As String
  GetInboundData = RecvBuffer
End Function

Public Sub SetData(sData As String)
    readLoc = 1
    RecvBuffer = sData
End Sub

Public Function GetOutboundData() As String
  GetOutboundData = SendBuffer
End Function


Public Function GetDWORD(Optional ByRef Data As String) As Long
Dim lReturn As Long
    
    If LenB(Data) Then
      Call CopyMemory(lReturn, ByVal Left$(Data, 4), 4)
      GetDWORD = lReturn
    'read from supplied
    Else
      Call CopyMemory(lReturn, ByVal Mid$(RecvBuffer, readLoc, 4), 4)
      GetDWORD = lReturn
      readLoc = readLoc + 4
    'read from recv packet
    End If
    
End Function


Public Function GetWORD(ByRef Data As String) As Long
Dim lReturn As Long
    
      Call CopyMemory(lReturn, ByVal Data, 2)
      GetWORD = lReturn
    
End Function
'this is only used to get packet length so no special read  locations ect required

Public Function GetNTstring() As String
Dim StringLoc As Long

    StringLoc = InStr(readLoc, RecvBuffer, vbNullChar)
    If StringLoc <> 0 Then
        GetNTstring = Mid$(RecvBuffer, readLoc, StringLoc - readLoc)
        readLoc = StringLoc + 1
    Else
        GetNTstring = RecvBuffer
        readLoc = Len(RecvBuffer) + 1
    End If

End Function

Public Function GetLenSTRING(ByRef Length As Byte) As String
    GetLenSTRING = Mid$(RecvBuffer, readLoc, Length)
    readLoc = readLoc + Length
End Function
